/*							-- DO NOT EDIT --
 * Generated by smidump version 0.4.8:
 *   smidump -f scli DISMAN-SCRIPT-MIB
 *
 * Derived from DISMAN-SCRIPT-MIB:
 *   This MIB module defines a set of objects that allow to
 *   delegate management scripts to distributed managers.
 *
 * Revision 2001-08-21 00:00:
 *   Revised version, published as RFC 3165.
 *   
 *   This revision introduces several new objects: smScriptError,
 *   smScriptLastChange, smLaunchError, smLaunchLastChange,
 *   smLaunchRowExpireTime, smRunResultTime, and smRunErrorTime.
 *   
 *   The following existing objects were updated: the maximum
 *   value of smRunLifeTime now disables the timer, an
 *   autostart value was added to the smLaunchAdminStatus
 *   object, and a new expired state was added to the
 *   smLaunchOperStatus object.
 *   
 *   A new smScriptException notification has been added to
 *   support runtime error notifications.
 *   
 *   Created new conformance and compliance statements that
 *   take care of the new objects and notifications.
 *   
 *   Clarifications have been added in several places to remove
 *   ambiguities or contradictions that were discovered and
 *   reported by implementors.
 *
 * Revision 1999-02-22 18:00:
 *   Initial version, published as RFC 2592.
 *
 * $Id: disman-script-mib.h 3180 2009-07-29 22:36:13Z schoenw $
 */

#ifndef _DISMAN_SCRIPT_MIB_H_
#define _DISMAN_SCRIPT_MIB_H_

#include "gsnmp.h"

G_BEGIN_DECLS

/*
 * Tables to map enumerations to strings and vice versa.
 */

#define DISMAN_SCRIPT_MIB_SMSCRIPTADMINSTATUS_ENABLED  1
#define DISMAN_SCRIPT_MIB_SMSCRIPTADMINSTATUS_DISABLED 2
#define DISMAN_SCRIPT_MIB_SMSCRIPTADMINSTATUS_EDITING  3

extern GNetSnmpEnum const disman_script_mib_enums_smScriptAdminStatus[];

#define DISMAN_SCRIPT_MIB_SMSCRIPTOPERSTATUS_ENABLED           1
#define DISMAN_SCRIPT_MIB_SMSCRIPTOPERSTATUS_DISABLED          2
#define DISMAN_SCRIPT_MIB_SMSCRIPTOPERSTATUS_EDITING           3
#define DISMAN_SCRIPT_MIB_SMSCRIPTOPERSTATUS_RETRIEVING        4
#define DISMAN_SCRIPT_MIB_SMSCRIPTOPERSTATUS_COMPILING         5
#define DISMAN_SCRIPT_MIB_SMSCRIPTOPERSTATUS_NOSUCHSCRIPT      6
#define DISMAN_SCRIPT_MIB_SMSCRIPTOPERSTATUS_ACCESSDENIED      7
#define DISMAN_SCRIPT_MIB_SMSCRIPTOPERSTATUS_WRONGLANGUAGE     8
#define DISMAN_SCRIPT_MIB_SMSCRIPTOPERSTATUS_WRONGVERSION      9
#define DISMAN_SCRIPT_MIB_SMSCRIPTOPERSTATUS_COMPILATIONFAILED 10
#define DISMAN_SCRIPT_MIB_SMSCRIPTOPERSTATUS_NORESOURCESLEFT   11
#define DISMAN_SCRIPT_MIB_SMSCRIPTOPERSTATUS_UNKNOWNPROTOCOL   12
#define DISMAN_SCRIPT_MIB_SMSCRIPTOPERSTATUS_PROTOCOLFAILURE   13
#define DISMAN_SCRIPT_MIB_SMSCRIPTOPERSTATUS_GENERICERROR      14

extern GNetSnmpEnum const disman_script_mib_enums_smScriptOperStatus[];

#define DISMAN_SCRIPT_MIB_SMLAUNCHCONTROL_ABORT   1
#define DISMAN_SCRIPT_MIB_SMLAUNCHCONTROL_SUSPEND 2
#define DISMAN_SCRIPT_MIB_SMLAUNCHCONTROL_RESUME  3
#define DISMAN_SCRIPT_MIB_SMLAUNCHCONTROL_NOP     4

extern GNetSnmpEnum const disman_script_mib_enums_smLaunchControl[];

#define DISMAN_SCRIPT_MIB_SMLAUNCHADMINSTATUS_ENABLED   1
#define DISMAN_SCRIPT_MIB_SMLAUNCHADMINSTATUS_DISABLED  2
#define DISMAN_SCRIPT_MIB_SMLAUNCHADMINSTATUS_AUTOSTART 3

extern GNetSnmpEnum const disman_script_mib_enums_smLaunchAdminStatus[];

#define DISMAN_SCRIPT_MIB_SMLAUNCHOPERSTATUS_ENABLED  1
#define DISMAN_SCRIPT_MIB_SMLAUNCHOPERSTATUS_DISABLED 2
#define DISMAN_SCRIPT_MIB_SMLAUNCHOPERSTATUS_EXPIRED  3

extern GNetSnmpEnum const disman_script_mib_enums_smLaunchOperStatus[];

#define DISMAN_SCRIPT_MIB_SMRUNEXITCODE_NOERROR           1
#define DISMAN_SCRIPT_MIB_SMRUNEXITCODE_HALTED            2
#define DISMAN_SCRIPT_MIB_SMRUNEXITCODE_LIFETIMEEXCEEDED  3
#define DISMAN_SCRIPT_MIB_SMRUNEXITCODE_NORESOURCESLEFT   4
#define DISMAN_SCRIPT_MIB_SMRUNEXITCODE_LANGUAGEERROR     5
#define DISMAN_SCRIPT_MIB_SMRUNEXITCODE_RUNTIMEERROR      6
#define DISMAN_SCRIPT_MIB_SMRUNEXITCODE_INVALIDARGUMENT   7
#define DISMAN_SCRIPT_MIB_SMRUNEXITCODE_SECURITYVIOLATION 8
#define DISMAN_SCRIPT_MIB_SMRUNEXITCODE_GENERICERROR      9

extern GNetSnmpEnum const disman_script_mib_enums_smRunExitCode[];

#define DISMAN_SCRIPT_MIB_SMRUNCONTROL_ABORT   1
#define DISMAN_SCRIPT_MIB_SMRUNCONTROL_SUSPEND 2
#define DISMAN_SCRIPT_MIB_SMRUNCONTROL_RESUME  3
#define DISMAN_SCRIPT_MIB_SMRUNCONTROL_NOP     4

extern GNetSnmpEnum const disman_script_mib_enums_smRunControl[];

#define DISMAN_SCRIPT_MIB_SMRUNSTATE_INITIALIZING 1
#define DISMAN_SCRIPT_MIB_SMRUNSTATE_EXECUTING    2
#define DISMAN_SCRIPT_MIB_SMRUNSTATE_SUSPENDING   3
#define DISMAN_SCRIPT_MIB_SMRUNSTATE_SUSPENDED    4
#define DISMAN_SCRIPT_MIB_SMRUNSTATE_RESUMING     5
#define DISMAN_SCRIPT_MIB_SMRUNSTATE_ABORTING     6
#define DISMAN_SCRIPT_MIB_SMRUNSTATE_TERMINATED   7

extern GNetSnmpEnum const disman_script_mib_enums_smRunState[];


/*
 * Tables to map notifications to strings and vice versa.
 */

#define DISMAN_SCRIPT_MIB_SMSCRIPTABORT	1,3,6,1,2,1,64,2,0,1
#define DISMAN_SCRIPT_MIB_SMSCRIPTRESULT	1,3,6,1,2,1,64,2,0,2
#define DISMAN_SCRIPT_MIB_SMSCRIPTEXCEPTION	1,3,6,1,2,1,64,2,0,3

extern GNetSnmpIdentity const disman_script_mib_notifications[];

/*
 * C type definitions for DISMAN-SCRIPT-MIB::smLangEntry.
 */

#define DISMAN_SCRIPT_MIB_SMLANGLANGUAGE (1 << 0) 
#define DISMAN_SCRIPT_MIB_SMLANGVERSION  (1 << 1) 
#define DISMAN_SCRIPT_MIB_SMLANGVENDOR   (1 << 2) 
#define DISMAN_SCRIPT_MIB_SMLANGREVISION (1 << 3) 
#define DISMAN_SCRIPT_MIB_SMLANGDESCR    (1 << 4) 

typedef struct {
    gint32   smLangIndex;         /* na */
    guint32  *smLangLanguage;     /* ro ObjectIdentifier */
#define DISMAN_SCRIPT_MIB_SMLANGLANGUAGEMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMLANGLANGUAGEMAXLENGTH 128
    guint16  _smLangLanguageLength;
    guchar   *smLangVersion;      /* ro */
#define DISMAN_SCRIPT_MIB_SMLANGVERSIONMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMLANGVERSIONMAXLENGTH 32
    guint16  _smLangVersionLength;
    guint32  *smLangVendor;       /* ro ObjectIdentifier */
#define DISMAN_SCRIPT_MIB_SMLANGVENDORMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMLANGVENDORMAXLENGTH 128
    guint16  _smLangVendorLength;
    guchar   *smLangRevision;     /* ro */
#define DISMAN_SCRIPT_MIB_SMLANGREVISIONMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMLANGREVISIONMAXLENGTH 32
    guint16  _smLangRevisionLength;
    guchar   *smLangDescr;        /* ro SNMP-FRAMEWORK-MIB::SnmpAdminString */
#define DISMAN_SCRIPT_MIB_SMLANGDESCRMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMLANGDESCRMAXLENGTH 255
    guint16  _smLangDescrLength;
} disman_script_mib_smLangEntry_t;

extern void
disman_script_mib_get_smLangTable(GNetSnmp *s, disman_script_mib_smLangEntry_t ***smLangEntry, gint64 mask, GError **error);

extern void
disman_script_mib_free_smLangTable(disman_script_mib_smLangEntry_t **smLangEntry);

extern disman_script_mib_smLangEntry_t *
disman_script_mib_new_smLangEntry(void);

extern void
disman_script_mib_get_smLangEntry(GNetSnmp *s, disman_script_mib_smLangEntry_t **smLangEntry, gint32 smLangIndex, gint64 mask, GError **error);

extern void
disman_script_mib_free_smLangEntry(disman_script_mib_smLangEntry_t *smLangEntry);

/*
 * C type definitions for DISMAN-SCRIPT-MIB::smExtsnEntry.
 */

#define DISMAN_SCRIPT_MIB_SMEXTSNEXTENSION (1 << 0) 
#define DISMAN_SCRIPT_MIB_SMEXTSNVERSION   (1 << 1) 
#define DISMAN_SCRIPT_MIB_SMEXTSNVENDOR    (1 << 2) 
#define DISMAN_SCRIPT_MIB_SMEXTSNREVISION  (1 << 3) 
#define DISMAN_SCRIPT_MIB_SMEXTSNDESCR     (1 << 4) 

typedef struct {
    gint32   smLangIndex;           /* na */
    gint32   smExtsnIndex;          /* na */
    guint32  *smExtsnExtension;     /* ro ObjectIdentifier */
#define DISMAN_SCRIPT_MIB_SMEXTSNEXTENSIONMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMEXTSNEXTENSIONMAXLENGTH 128
    guint16  _smExtsnExtensionLength;
    guchar   *smExtsnVersion;       /* ro */
#define DISMAN_SCRIPT_MIB_SMEXTSNVERSIONMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMEXTSNVERSIONMAXLENGTH 32
    guint16  _smExtsnVersionLength;
    guint32  *smExtsnVendor;        /* ro ObjectIdentifier */
#define DISMAN_SCRIPT_MIB_SMEXTSNVENDORMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMEXTSNVENDORMAXLENGTH 128
    guint16  _smExtsnVendorLength;
    guchar   *smExtsnRevision;      /* ro */
#define DISMAN_SCRIPT_MIB_SMEXTSNREVISIONMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMEXTSNREVISIONMAXLENGTH 32
    guint16  _smExtsnRevisionLength;
    guchar   *smExtsnDescr;         /* ro SNMP-FRAMEWORK-MIB::SnmpAdminString */
#define DISMAN_SCRIPT_MIB_SMEXTSNDESCRMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMEXTSNDESCRMAXLENGTH 255
    guint16  _smExtsnDescrLength;
} disman_script_mib_smExtsnEntry_t;

extern void
disman_script_mib_get_smExtsnTable(GNetSnmp *s, disman_script_mib_smExtsnEntry_t ***smExtsnEntry, gint64 mask, GError **error);

extern void
disman_script_mib_free_smExtsnTable(disman_script_mib_smExtsnEntry_t **smExtsnEntry);

extern disman_script_mib_smExtsnEntry_t *
disman_script_mib_new_smExtsnEntry(void);

extern void
disman_script_mib_get_smExtsnEntry(GNetSnmp *s, disman_script_mib_smExtsnEntry_t **smExtsnEntry, gint32 smLangIndex, gint32 smExtsnIndex, gint64 mask, GError **error);

extern void
disman_script_mib_free_smExtsnEntry(disman_script_mib_smExtsnEntry_t *smExtsnEntry);

/*
 * C type definitions for DISMAN-SCRIPT-MIB::smScriptEntry.
 */

#define DISMAN_SCRIPT_MIB_SMSCRIPTDESCR       (1 << 0) 
#define DISMAN_SCRIPT_MIB_SMSCRIPTLANGUAGE    (1 << 1) 
#define DISMAN_SCRIPT_MIB_SMSCRIPTSOURCE      (1 << 2) 
#define DISMAN_SCRIPT_MIB_SMSCRIPTADMINSTATUS (1 << 3) 
#define DISMAN_SCRIPT_MIB_SMSCRIPTOPERSTATUS  (1 << 4) 
#define DISMAN_SCRIPT_MIB_SMSCRIPTSTORAGETYPE (1 << 5) 
#define DISMAN_SCRIPT_MIB_SMSCRIPTROWSTATUS   (1 << 6) 
#define DISMAN_SCRIPT_MIB_SMSCRIPTERROR       (1 << 7) 
#define DISMAN_SCRIPT_MIB_SMSCRIPTLASTCHANGE  (1 << 8) 

typedef struct {
    guchar   smScriptOwner[32];        /* na */
#define DISMAN_SCRIPT_MIB_SMSCRIPTOWNERMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMSCRIPTOWNERMAXLENGTH 32
    guint16  _smScriptOwnerLength;
    guchar   smScriptName[32];         /* na */
#define DISMAN_SCRIPT_MIB_SMSCRIPTNAMEMINLENGTH 1
#define DISMAN_SCRIPT_MIB_SMSCRIPTNAMEMAXLENGTH 32
    guint16  _smScriptNameLength;
    guchar   *smScriptDescr;           /* rw SNMP-FRAMEWORK-MIB::SnmpAdminString */
#define DISMAN_SCRIPT_MIB_SMSCRIPTDESCRMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMSCRIPTDESCRMAXLENGTH 255
    guint16  _smScriptDescrLength;
    gint32   *smScriptLanguage;        /* rw */
    guchar   *smScriptSource;          /* rw SNMPv2-TC::DisplayString */
#define DISMAN_SCRIPT_MIB_SMSCRIPTSOURCEMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMSCRIPTSOURCEMAXLENGTH 255
    guint16  _smScriptSourceLength;
    gint32   *smScriptAdminStatus;     /* rw */
    gint32   *smScriptOperStatus;      /* ro */
    gint32   *smScriptStorageType;     /* rw SNMPv2-TC::StorageType */
    gint32   *smScriptRowStatus;       /* rw SNMPv2-TC::RowStatus */
    guchar   *smScriptError;           /* ro SNMP-FRAMEWORK-MIB::SnmpAdminString */
#define DISMAN_SCRIPT_MIB_SMSCRIPTERRORMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMSCRIPTERRORMAXLENGTH 255
    guint16  _smScriptErrorLength;
    guchar   *smScriptLastChange;      /* ro SNMPv2-TC::DateAndTime */
#define DISMAN_SCRIPT_MIB_SMSCRIPTLASTCHANGEMINLENGTH 8
#define DISMAN_SCRIPT_MIB_SMSCRIPTLASTCHANGEMAXLENGTH 11
    guint16  _smScriptLastChangeLength;
} disman_script_mib_smScriptEntry_t;

extern void
disman_script_mib_get_smScriptTable(GNetSnmp *s, disman_script_mib_smScriptEntry_t ***smScriptEntry, gint64 mask, GError **error);

extern void
disman_script_mib_free_smScriptTable(disman_script_mib_smScriptEntry_t **smScriptEntry);

extern disman_script_mib_smScriptEntry_t *
disman_script_mib_new_smScriptEntry(void);

extern void
disman_script_mib_get_smScriptEntry(GNetSnmp *s, disman_script_mib_smScriptEntry_t **smScriptEntry, guchar *smScriptOwner, guint16 _smScriptOwnerLength, guchar *smScriptName, guint16 _smScriptNameLength, gint64 mask, GError **error);

extern void
disman_script_mib_set_smScriptEntry(GNetSnmp *s, disman_script_mib_smScriptEntry_t *smScriptEntry, gint64 mask, GError **error);

extern void
disman_script_mib_free_smScriptEntry(disman_script_mib_smScriptEntry_t *smScriptEntry);

/*
 * C type definitions for DISMAN-SCRIPT-MIB::smCodeEntry.
 */

#define DISMAN_SCRIPT_MIB_SMCODETEXT      (1 << 0) 
#define DISMAN_SCRIPT_MIB_SMCODEROWSTATUS (1 << 1) 

typedef struct {
    guchar   smScriptOwner[32];    /* na */
#define DISMAN_SCRIPT_MIB_SMSCRIPTOWNERMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMSCRIPTOWNERMAXLENGTH 32
    guint16  _smScriptOwnerLength;
    guchar   smScriptName[32];     /* na */
#define DISMAN_SCRIPT_MIB_SMSCRIPTNAMEMINLENGTH 1
#define DISMAN_SCRIPT_MIB_SMSCRIPTNAMEMAXLENGTH 32
    guint16  _smScriptNameLength;
    guint32  smCodeIndex;          /* na */
    guchar   *smCodeText;          /* rw */
#define DISMAN_SCRIPT_MIB_SMCODETEXTMINLENGTH 1
#define DISMAN_SCRIPT_MIB_SMCODETEXTMAXLENGTH 1024
    guint16  _smCodeTextLength;
    gint32   *smCodeRowStatus;     /* rw SNMPv2-TC::RowStatus */
} disman_script_mib_smCodeEntry_t;

extern void
disman_script_mib_get_smCodeTable(GNetSnmp *s, disman_script_mib_smCodeEntry_t ***smCodeEntry, gint64 mask, GError **error);

extern void
disman_script_mib_free_smCodeTable(disman_script_mib_smCodeEntry_t **smCodeEntry);

extern disman_script_mib_smCodeEntry_t *
disman_script_mib_new_smCodeEntry(void);

extern void
disman_script_mib_get_smCodeEntry(GNetSnmp *s, disman_script_mib_smCodeEntry_t **smCodeEntry, guchar *smScriptOwner, guint16 _smScriptOwnerLength, guchar *smScriptName, guint16 _smScriptNameLength, guint32 smCodeIndex, gint64 mask, GError **error);

extern void
disman_script_mib_set_smCodeEntry(GNetSnmp *s, disman_script_mib_smCodeEntry_t *smCodeEntry, gint64 mask, GError **error);

extern void
disman_script_mib_free_smCodeEntry(disman_script_mib_smCodeEntry_t *smCodeEntry);

/*
 * C type definitions for DISMAN-SCRIPT-MIB::smLaunchEntry.
 */

#define DISMAN_SCRIPT_MIB_SMLAUNCHSCRIPTOWNER   (1 << 0) 
#define DISMAN_SCRIPT_MIB_SMLAUNCHSCRIPTNAME    (1 << 1) 
#define DISMAN_SCRIPT_MIB_SMLAUNCHARGUMENT      (1 << 2) 
#define DISMAN_SCRIPT_MIB_SMLAUNCHMAXRUNNING    (1 << 3) 
#define DISMAN_SCRIPT_MIB_SMLAUNCHMAXCOMPLETED  (1 << 4) 
#define DISMAN_SCRIPT_MIB_SMLAUNCHLIFETIME      (1 << 5) 
#define DISMAN_SCRIPT_MIB_SMLAUNCHEXPIRETIME    (1 << 6) 
#define DISMAN_SCRIPT_MIB_SMLAUNCHSTART         (1 << 7) 
#define DISMAN_SCRIPT_MIB_SMLAUNCHCONTROL       (1 << 8) 
#define DISMAN_SCRIPT_MIB_SMLAUNCHADMINSTATUS   (1 << 9) 
#define DISMAN_SCRIPT_MIB_SMLAUNCHOPERSTATUS    (1 << 10) 
#define DISMAN_SCRIPT_MIB_SMLAUNCHRUNINDEXNEXT  (1 << 11) 
#define DISMAN_SCRIPT_MIB_SMLAUNCHSTORAGETYPE   (1 << 12) 
#define DISMAN_SCRIPT_MIB_SMLAUNCHROWSTATUS     (1 << 13) 
#define DISMAN_SCRIPT_MIB_SMLAUNCHERROR         (1 << 14) 
#define DISMAN_SCRIPT_MIB_SMLAUNCHLASTCHANGE    (1 << 15) 
#define DISMAN_SCRIPT_MIB_SMLAUNCHROWEXPIRETIME (1 << 16) 

typedef struct {
    guchar   smLaunchOwner[32];          /* na */
#define DISMAN_SCRIPT_MIB_SMLAUNCHOWNERMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMLAUNCHOWNERMAXLENGTH 32
    guint16  _smLaunchOwnerLength;
    guchar   smLaunchName[32];           /* na */
#define DISMAN_SCRIPT_MIB_SMLAUNCHNAMEMINLENGTH 1
#define DISMAN_SCRIPT_MIB_SMLAUNCHNAMEMAXLENGTH 32
    guint16  _smLaunchNameLength;
    guchar   *smLaunchScriptOwner;       /* rw */
#define DISMAN_SCRIPT_MIB_SMLAUNCHSCRIPTOWNERMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMLAUNCHSCRIPTOWNERMAXLENGTH 32
    guint16  _smLaunchScriptOwnerLength;
    guchar   *smLaunchScriptName;        /* rw */
#define DISMAN_SCRIPT_MIB_SMLAUNCHSCRIPTNAMEMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMLAUNCHSCRIPTNAMEMAXLENGTH 32
    guint16  _smLaunchScriptNameLength;
    guchar   *smLaunchArgument;          /* rw OctetString */
#define DISMAN_SCRIPT_MIB_SMLAUNCHARGUMENTMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMLAUNCHARGUMENTMAXLENGTH 65535
    guint16  _smLaunchArgumentLength;
    guint32  *smLaunchMaxRunning;        /* rw */
    guint32  *smLaunchMaxCompleted;      /* rw */
    gint32   *smLaunchLifeTime;          /* rw SNMPv2-TC::TimeInterval [centi-seconds] */
    gint32   *smLaunchExpireTime;        /* rw SNMPv2-TC::TimeInterval [centi-seconds] */
    gint32   *smLaunchStart;             /* rw */
    gint32   *smLaunchControl;           /* rw */
    gint32   *smLaunchAdminStatus;       /* rw */
    gint32   *smLaunchOperStatus;        /* ro */
    gint32   *smLaunchRunIndexNext;      /* ro */
    gint32   *smLaunchStorageType;       /* rw SNMPv2-TC::StorageType */
    gint32   *smLaunchRowStatus;         /* rw SNMPv2-TC::RowStatus */
    guchar   *smLaunchError;             /* ro SNMP-FRAMEWORK-MIB::SnmpAdminString */
#define DISMAN_SCRIPT_MIB_SMLAUNCHERRORMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMLAUNCHERRORMAXLENGTH 255
    guint16  _smLaunchErrorLength;
    guchar   *smLaunchLastChange;        /* ro SNMPv2-TC::DateAndTime */
#define DISMAN_SCRIPT_MIB_SMLAUNCHLASTCHANGEMINLENGTH 8
#define DISMAN_SCRIPT_MIB_SMLAUNCHLASTCHANGEMAXLENGTH 11
    guint16  _smLaunchLastChangeLength;
    gint32   *smLaunchRowExpireTime;     /* rw SNMPv2-TC::TimeInterval [centi-seconds] */
} disman_script_mib_smLaunchEntry_t;

extern void
disman_script_mib_get_smLaunchTable(GNetSnmp *s, disman_script_mib_smLaunchEntry_t ***smLaunchEntry, gint64 mask, GError **error);

extern void
disman_script_mib_free_smLaunchTable(disman_script_mib_smLaunchEntry_t **smLaunchEntry);

extern disman_script_mib_smLaunchEntry_t *
disman_script_mib_new_smLaunchEntry(void);

extern void
disman_script_mib_get_smLaunchEntry(GNetSnmp *s, disman_script_mib_smLaunchEntry_t **smLaunchEntry, guchar *smLaunchOwner, guint16 _smLaunchOwnerLength, guchar *smLaunchName, guint16 _smLaunchNameLength, gint64 mask, GError **error);

extern void
disman_script_mib_set_smLaunchEntry(GNetSnmp *s, disman_script_mib_smLaunchEntry_t *smLaunchEntry, gint64 mask, GError **error);

extern void
disman_script_mib_free_smLaunchEntry(disman_script_mib_smLaunchEntry_t *smLaunchEntry);

/*
 * C type definitions for DISMAN-SCRIPT-MIB::smRunEntry.
 */

#define DISMAN_SCRIPT_MIB_SMRUNARGUMENT   (1 << 0) 
#define DISMAN_SCRIPT_MIB_SMRUNSTARTTIME  (1 << 1) 
#define DISMAN_SCRIPT_MIB_SMRUNENDTIME    (1 << 2) 
#define DISMAN_SCRIPT_MIB_SMRUNLIFETIME   (1 << 3) 
#define DISMAN_SCRIPT_MIB_SMRUNEXPIRETIME (1 << 4) 
#define DISMAN_SCRIPT_MIB_SMRUNEXITCODE   (1 << 5) 
#define DISMAN_SCRIPT_MIB_SMRUNRESULT     (1 << 6) 
#define DISMAN_SCRIPT_MIB_SMRUNCONTROL    (1 << 7) 
#define DISMAN_SCRIPT_MIB_SMRUNSTATE      (1 << 8) 
#define DISMAN_SCRIPT_MIB_SMRUNERROR      (1 << 9) 
#define DISMAN_SCRIPT_MIB_SMRUNRESULTTIME (1 << 10) 
#define DISMAN_SCRIPT_MIB_SMRUNERRORTIME  (1 << 11) 

typedef struct {
    guchar   smLaunchOwner[32];    /* na */
#define DISMAN_SCRIPT_MIB_SMLAUNCHOWNERMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMLAUNCHOWNERMAXLENGTH 32
    guint16  _smLaunchOwnerLength;
    guchar   smLaunchName[32];     /* na */
#define DISMAN_SCRIPT_MIB_SMLAUNCHNAMEMINLENGTH 1
#define DISMAN_SCRIPT_MIB_SMLAUNCHNAMEMAXLENGTH 32
    guint16  _smLaunchNameLength;
    gint32   smRunIndex;           /* na */
    guchar   *smRunArgument;       /* ro OctetString */
#define DISMAN_SCRIPT_MIB_SMRUNARGUMENTMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMRUNARGUMENTMAXLENGTH 65535
    guint16  _smRunArgumentLength;
    guchar   *smRunStartTime;      /* ro SNMPv2-TC::DateAndTime */
#define DISMAN_SCRIPT_MIB_SMRUNSTARTTIMEMINLENGTH 8
#define DISMAN_SCRIPT_MIB_SMRUNSTARTTIMEMAXLENGTH 11
    guint16  _smRunStartTimeLength;
    guchar   *smRunEndTime;        /* ro SNMPv2-TC::DateAndTime */
#define DISMAN_SCRIPT_MIB_SMRUNENDTIMEMINLENGTH 8
#define DISMAN_SCRIPT_MIB_SMRUNENDTIMEMAXLENGTH 11
    guint16  _smRunEndTimeLength;
    gint32   *smRunLifeTime;       /* rw SNMPv2-TC::TimeInterval [centi-seconds] */
    gint32   *smRunExpireTime;     /* rw SNMPv2-TC::TimeInterval [centi-seconds] */
    gint32   *smRunExitCode;       /* ro */
    guchar   *smRunResult;         /* ro OctetString */
#define DISMAN_SCRIPT_MIB_SMRUNRESULTMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMRUNRESULTMAXLENGTH 65535
    guint16  _smRunResultLength;
    gint32   *smRunControl;        /* rw */
    gint32   *smRunState;          /* ro */
    guchar   *smRunError;          /* ro SNMP-FRAMEWORK-MIB::SnmpAdminString */
#define DISMAN_SCRIPT_MIB_SMRUNERRORMINLENGTH 0
#define DISMAN_SCRIPT_MIB_SMRUNERRORMAXLENGTH 255
    guint16  _smRunErrorLength;
    guchar   *smRunResultTime;     /* ro SNMPv2-TC::DateAndTime */
#define DISMAN_SCRIPT_MIB_SMRUNRESULTTIMEMINLENGTH 8
#define DISMAN_SCRIPT_MIB_SMRUNRESULTTIMEMAXLENGTH 11
    guint16  _smRunResultTimeLength;
    guchar   *smRunErrorTime;      /* ro SNMPv2-TC::DateAndTime */
#define DISMAN_SCRIPT_MIB_SMRUNERRORTIMEMINLENGTH 8
#define DISMAN_SCRIPT_MIB_SMRUNERRORTIMEMAXLENGTH 11
    guint16  _smRunErrorTimeLength;
} disman_script_mib_smRunEntry_t;

extern void
disman_script_mib_get_smRunTable(GNetSnmp *s, disman_script_mib_smRunEntry_t ***smRunEntry, gint64 mask, GError **error);

extern void
disman_script_mib_free_smRunTable(disman_script_mib_smRunEntry_t **smRunEntry);

extern disman_script_mib_smRunEntry_t *
disman_script_mib_new_smRunEntry(void);

extern void
disman_script_mib_get_smRunEntry(GNetSnmp *s, disman_script_mib_smRunEntry_t **smRunEntry, guchar *smLaunchOwner, guint16 _smLaunchOwnerLength, guchar *smLaunchName, guint16 _smLaunchNameLength, gint32 smRunIndex, gint64 mask, GError **error);

extern void
disman_script_mib_set_smRunEntry(GNetSnmp *s, disman_script_mib_smRunEntry_t *smRunEntry, gint64 mask, GError **error);

extern void
disman_script_mib_free_smRunEntry(disman_script_mib_smRunEntry_t *smRunEntry);


G_END_DECLS

#endif /* _DISMAN_SCRIPT_MIB_H_ */
